# Generated by Django 4.1.5 on 2023-01-07 23:52

import auto_prefetch
import django.core.validators
import django.db.models.deletion
import django.db.models.manager
import django.utils.timezone
import django_fsm
import django_utils.storage.backends
import localflavor.generic.models
import model_utils.fields
from django.conf import settings
from django.db import migrations, models

import expense_report.validators


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("auth", "0012_alter_user_first_name_max_length"),
    ]

    operations = [
        migrations.CreateModel(
            name="ExpenseReport",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("state", django_fsm.FSMField(default="draft", max_length=50)),
                (
                    "state_changed",
                    model_utils.fields.MonitorField(
                        default=django.utils.timezone.now, monitor="state"
                    ),
                ),
                ("submitted_at", models.DateTimeField(blank=True, null=True)),
                (
                    "approved_by",
                    models.CharField(
                        choices=[
                            ("PRESIDENCY", "Présidence"),
                            ("SECRETARY", "Secrétariat"),
                            ("TREASURY", "Trésorerie"),
                        ],
                        max_length=10,
                    ),
                ),
                (
                    "event",
                    models.CharField(
                        choices=[
                            ("GCC", "GCC!"),
                            ("ER", "Épreuve régionale"),
                            ("FINAL", "Finale Prologin"),
                            ("OTHER", "Autre"),
                        ],
                        max_length=10,
                    ),
                ),
                ("event_description", models.TextField()),
                ("description", models.TextField()),
                (
                    "document",
                    models.FileField(
                        blank=True,
                        null=True,
                        storage=django_utils.storage.backends.PrivateMediaStorage,
                        upload_to="expense_report/expense_reports/",
                        validators=[
                            django.core.validators.FileExtensionValidator(
                                allowed_extensions=("pdf",)
                            ),
                            expense_report.validators.validate_is_pdf,
                        ],
                    ),
                ),
                (
                    "document_id",
                    models.CharField(
                        blank=True, max_length=32, null=True, unique=True
                    ),
                ),
                ("reason", models.TextField(blank=True)),
                (
                    "created_by",
                    auto_prefetch.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="created_by",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "modified_by",
                    auto_prefetch.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="last_modified_by",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "ordering": ("-state", "-submitted_at", "-created"),
                "permissions": (
                    ("manage_expensereport", "Can approve an expense report"),
                ),
                "abstract": False,
                "base_manager_name": "prefetch_manager",
            },
            managers=[
                ("objects", django.db.models.manager.Manager()),
                ("prefetch_manager", django.db.models.manager.Manager()),
            ],
        ),
        migrations.CreateModel(
            name="UserBankingInformation",
            fields=[
                (
                    "user",
                    auto_prefetch.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        related_name="banking_information",
                        serialize=False,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "file",
                    models.FileField(
                        null=True,
                        storage=django_utils.storage.backends.PrivateMediaStorage,
                        upload_to="expense_report/banking_informations/",
                        validators=[
                            django.core.validators.FileExtensionValidator(
                                allowed_extensions=("pdf",)
                            ),
                            expense_report.validators.validate_is_pdf,
                        ],
                    ),
                ),
                (
                    "iban",
                    localflavor.generic.models.IBANField(
                        include_countries=(
                            "AT",
                            "BE",
                            "BG",
                            "CH",
                            "CY",
                            "CZ",
                            "DE",
                            "DK",
                            "EE",
                            "ES",
                            "FI",
                            "FR",
                            "GB",
                            "GI",
                            "GR",
                            "HR",
                            "HU",
                            "IE",
                            "IS",
                            "IT",
                            "LI",
                            "LT",
                            "LU",
                            "LV",
                            "MC",
                            "MT",
                            "NL",
                            "NO",
                            "PL",
                            "PT",
                            "RO",
                            "SE",
                            "SI",
                            "SK",
                            "SM",
                        ),
                        max_length=34,
                        null=True,
                        use_nordea_extensions=False,
                    ),
                ),
                (
                    "bic",
                    localflavor.generic.models.BICField(
                        max_length=11, null=True
                    ),
                ),
                ("validated", models.BooleanField(default=False)),
            ],
            options={
                "abstract": False,
                "base_manager_name": "prefetch_manager",
            },
            managers=[
                ("objects", django.db.models.manager.Manager()),
                ("prefetch_manager", django.db.models.manager.Manager()),
            ],
        ),
        migrations.CreateModel(
            name="ExpenseReportEntry",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("date", models.DateField()),
                (
                    "expense_type",
                    models.CharField(
                        choices=[
                            ("TRANSPORT", "Transport"),
                            ("ACCOMODATION", "Hébergement"),
                            ("MEAL", "Repas"),
                            ("PURCHASE", "Achat"),
                            ("OTHER", "Autre"),
                        ],
                        max_length=12,
                    ),
                ),
                ("description", models.TextField()),
                (
                    "amount",
                    models.DecimalField(decimal_places=2, max_digits=7),
                ),
                (
                    "proof",
                    models.FileField(
                        storage=django_utils.storage.backends.PrivateMediaStorage,
                        upload_to="expense_report/expense_report_entry_proof/",
                        validators=[
                            django.core.validators.FileExtensionValidator(
                                allowed_extensions=("pdf",)
                            ),
                            expense_report.validators.validate_is_pdf,
                        ],
                    ),
                ),
                (
                    "account_source",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                (
                    "account_dest",
                    models.CharField(blank=True, max_length=200, null=True),
                ),
                (
                    "expense_report",
                    auto_prefetch.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="entries",
                        to="expense_report.expensereport",
                    ),
                ),
            ],
            options={
                "ordering": ("date", "expense_type", "amount"),
                "abstract": False,
                "base_manager_name": "prefetch_manager",
            },
            managers=[
                ("objects", django.db.models.manager.Manager()),
                ("prefetch_manager", django.db.models.manager.Manager()),
            ],
        ),
    ]
